@ echo off

:: make_lib_index-files.bat
:: creates index.mnu and subsequent *.mnu files for a library structure
:: (c) Daniel Perak 2007
:: this program is freeware and may be distributed wies passt.
::
:: syntax:   make_lib_index-files.bat [path]\folder

:: 070323 V0.1 first working version

if not defined temp goto echo Variable "TEMP" ist nicht definiert! & goto :error

if exist %temp%\tmpfile.$$$ del %temp%\tmpfile.$$$

set root_folder=%~1
rem wie krieg ich die eventuellen anfhrungszeichen weg?
if not exist "%root_folder%" echo. The folder You specified was not found! & goto :error

cls
echo. Achtung!!
echo. Alle *.mnu - Dateien werden geloescht.
echo. Bitte waehlen: [J]a oder [N]ein ?
set/p choice=
if /i "%choice%"=="n" echo abbruch! & goto :error


echo> %temp%\tmpfile.$$$ %root_folder%
dir /s /b /ad /on %root_folder% >> %temp%\tmpfile.$$$

for /f "tokens=*" %%a in (%temp%\tmpfile.$$$) do call :begin_loop_folders "%%a"
goto :end_loop_folders
	:begin_loop_folders
	echo. bearbeite %~1
	if exist "%~1\*.mnu" del "%~1\*.mnu"
	set mnu_text=%~n1
	echo %mnu_text:_=#% > "%temp%\tmp_mnu.$$$"
	echo #>> "%temp%\tmp_mnu.$$$"
	echo #>> "%temp%\tmp_mnu.$$$"

	for /f "tokens=*" %%b in ('dir /b /on %~1') do call :begin_loop_files "%~1" "%%b"
	goto :end_loop_files
		:begin_loop_files
		set mnu_text=%~n2
		dir %~1\%~2 | find /i "<DIR>" 1> nul 2> nul
		if "%errorlevel%"=="0" (
			set slash=/
			set extension=
			) else (
			set slash=
			set extension=%~x2
			)
		echo %slash%%mnu_text: =#%%extension%>> "%temp%\tmp_mnu.$$$"
		echo #>> "%temp%\tmp_mnu.$$$"
		echo #>> "%temp%\tmp_mnu.$$$"
		goto :eof
		:end_loop_files
	move "%temp%\tmp_mnu.$$$" "%~1\%~n1.mnu"
	echo. fertig!
	echo.
	goto :eof
	:end_loop_folders

del "%temp%\tmpfile.$$$"

echo finished!

:error
pause

:end
:eof